// Bezeichnung: Infobox
// Autor      : Peter Weigel

import java.awt.*;
import java.awt.event.*;

public class AboutBox extends Dialog implements WindowListener, ActionListener {

  public AboutBox(Frame frame) {
    super(frame, "Information", true);
    this.addWindowListener(this);
    Panel p;
    Panel q;
    Button b;
    Label l;
    TextArea t;
    setFont(new Font("Arial",0,12));
    add(p = new BorderPanel(new BorderLayout(10,10)));
    p.add(b = new Button("OK"), BorderLayout.SOUTH);
    b.addActionListener(this);
    p.add(p = new Panel(new BorderLayout()), BorderLayout.NORTH);
    p.add(l = new Label(vasa.title(), Label.CENTER),BorderLayout.NORTH);
    l.setFont(new Font("Arial",1,10));l.setForeground(Color.red);
    p.add(t = new TextArea("",4,1,TextArea.SCROLLBARS_NONE), BorderLayout.SOUTH);
    p.add(q = new Panel(new GridLayout(0,1)), BorderLayout.CENTER);
    p.add(p = new Panel(new GridLayout(0,1)), BorderLayout.WEST);
    p.setFont(new Font("Arial",1,12));p.setForeground(Color.blue);
    p.add(new Label("Version"));q.add(new Label(vasa.version()));
    p.add(new Label("Autor"));q.add(new Label(vasa.autor()));
    p.add(new Label("URL"));q.add(new Label(vasa.url()));
    p.add(new Label("E-Mail"));q.add(new Label(vasa.email()));
    t.setEditable(false);
    t.setFont(new Font("Arial",0,10));
    t.setText("Diese Anwendung demonstriert bzw. visualisiert die Funktionsweise aller uns bekannten allgemeinen Sortieralgorithmen. Diese Anwendung ist frei, sie kann beliebig angewendet und verndert werden. Die Urheber (das sind wir) mssen stets genannt werden!");
    t.setBackground(Color.white);
    setResizable(false);
    pack();
    Point fp = frame.getLocation();
    Dimension fd = frame.getSize();
    Dimension td = this.getSize();
    setLocation((fd.width-td.width)/2+fp.x,(fd.height-td.height)/2+fp.y);
    setVisible(true);
  }

  public void actionPerformed(ActionEvent evt) {dispose();}
  public void windowClosed(WindowEvent ev) {}
  public void windowDeiconified(WindowEvent ev) {}
  public void windowIconified(WindowEvent ev) {}
  public void windowActivated(WindowEvent ev) {}
  public void windowDeactivated(WindowEvent ev) {}
  public void windowOpened(WindowEvent ev) {}
  public void windowClosing(WindowEvent ev) {dispose();}

}
