// Peter Weigel

// Bitonic Mergesort
// Variante 1+5

package pefas.sort;

import pefas.field.ifield;

public class btmsort15 extends sort {

  public void sort(ifield A, int l, int r) {
    sort(A, l, r, true);
  }
  public void sort(ifield A, int l, int r, boolean asc) {
    if (l < r) {
      int q= (l+r)/2;
      sort(A, l, q, true);
      sort(A, q+1, r, false);
      merge(A, l, r, asc);
    }
  }

  protected void merge(ifield A, int l, int r, boolean asc) {
    int c;
    if (!asc) { c= r; r= l; l= c;}
    c = asc ? +1 : -1;
    while (l != r) {
      if (A.gt(l, r)) {
        A.move(r, l);
      }
      l += c;
    }
  }

}
